15、3 Sum - 三数之和

https://leetcode-cn.com/problems/3sum/

Given an array nums of n integers, are there elements a, b, c in nums such that a + b + c = 0? Find all unique triplets(三个一组) in the array which gives the sum of zero.

Note:

The solution set must not contain duplicate triplets.

Example:

Given array nums = [-1, 0, 1, 2, -1, -4],

A solution set is:

[
  [-1, 0, 1],
  [-1, -1, 2]
]

分析题目:给定一个整数数组,结果返回无重复和为0的三元组;

首先想到的就是三层循环,简单暴力,先考虑一下重复问题:

1、元素重复但所在位置不同,如三元组(a,b,c),取该类型时,形如(b,a,c)、(c,a,b)则不可取,考虑排序有 a<=b<=c,保证了只有(a,b,c)这个顺序会被枚举到;

2、完全重复,对于每一重循环而言,相邻两次枚举的元素相同,会造成重复,如:[0,1,2,2,2,3]在第三层循环会多次取2对比 ,[0,0,0,1,2,3]在第一层会多次取0对比(实际只需要取一次就行了),需要将循环「跳到」下一个不相同的元素;

代码如下:

public List<List<Integer>> threeSum(int[] nums) {
        int length = nums.length;
        Arrays.sort(nums);
        List<List<Integer>> result = new ArrayList<List<Integer>>();
        for(int i = 0; i < length; i++){
            if (i > 0 && nums[i] == nums[i - 1]) {
                continue;
            }
            for(int j = i + 1; j < length; j++){
                if (j > i + 1 && nums[j] == nums[j - 1]) {
                    continue;
                }
                for(int k = j +1; k < length; k++){
                    if (k > j + 1 && nums[k] == nums[k - 1]) {
                        continue;
                    }
                    
                    if(nums[i]+nums[j]+nums[k] == 0){
                        result.add(Arrays.asList(nums[i],nums[j],nums[k]));
                    }
                }
            }
        }
        return result;
    }

然而现实是残酷的:

太过暴力也不好,三层for循环所带来O(n^3)的时间复杂度,n稍大一点就会导致超时;

优化方案:三指针(双指针),由a+b+c=0 -> a不变,将b,c作为一个整体a+(b+c)=0,b增大时(指针右移),为保持等式成立,c需要减小(指针左移);b初始下标为a下标+1,c初始下标为数组长度-1;b从左往右移,c从右往左移;直到b、c相遇时截止(保证b指针在c指针左侧);

双指针的方法,将枚举的时间复杂度从 O(N^2)减少至O(N)。为什么是O(N) 呢?这是因为在枚举的过程每一步中,「左指针」会向右移动一个位置(也就是 b),而「右指针」会向左移动若干个位置,这个与数组的元素有关,但我们知道它一共会移动的位置数为 O(N)

 

int length = nums.length;
        Arrays.sort(nums);
        List<List<Integer>> result = new ArrayList<List<Integer>>();
        for(int i = 0; i < length; i++){
            //保证不重复取相同数字
            if (i > 0 && nums[i] == nums[i - 1]) {
                continue;
            }
            //c指针初始指向数组的最右端,a值必定<=0
            int k = length - 1;
            int firstNum = nums[i];
            for(int j = i + 1; j < length; j++){
                if (j > i + 1 && nums[j] == nums[j - 1]) {
                    continue;
                }
                //保证b指针在c指针的左侧
                while (j < k && nums[j] + nums[k] > -firstNum ) {
                    --k;
                }

                //指针重合,结束
                if (j == k) {
                    break;
                }
       
                if(nums[i]+nums[j]+nums[k] == 0){
                    result.add(Arrays.asList(nums[i],nums[j],nums[k]));
                }
                
            }
        }
        return result;
    }

参考:https://leetcode-cn.com/problems/3sum/solution/san-shu-zhi-he-by-leetcode-solution/

 

 

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值